//
//  Display.java
//  hola
//
//  Created by Miguel Angel Montao Medina on 26/10/05.

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.text.*;
import java.util.*;

public class Display extends JComponent{
	public LinkedList datos = new LinkedList(); 
	private boolean grid, showx, showy;
	final static int xOff=50;
	final static int yOff=20;
	private float xmin, xmax, xdiv;
	private float ymin, ymax, ydiv;
	private int maxdatos;
	private int iniXOffset;
	public Display(){
		grid=false;
		xmin=0;
		ymin=0;
		xmax=1;
		ymax=1;
		xdiv=5;
		ydiv=5;
		showx=false;
		showy=false;
		iniXOffset=0;
	}
	
	public void setAxis(float xmin, float xmax, float ymin, float ymax, float xdiv, float ydiv){
		this.xmin=xmin;
		this.ymin=ymin;
		this.xmax=xmax;
		this.ymax=ymax;
		this.xdiv=xdiv;
		this.ydiv=ydiv;
	}
	
	public void showGrid(boolean s){
		grid=s;
	}
	
	public void showXAxis(boolean s){
		showx=s;
	}
	
	public void showYAxis(boolean s){
		showy=s;
	}
	
	public void setMaxDatos(int m){
		maxdatos=m;
	}
	
	public void setIniXOffset(int i){
		iniXOffset=i;
	}
	
	public void paint(Graphics g){
		int i,j;
		float px,py;
		float vx,vy;
		float m,n,t;
		Ellipse2D ell;
		Rectangle2D r;
		Dimension size=getSize();
		Graphics2D g2=(Graphics2D) g;

		Font f=g2.getFont();
		FontMetrics fm = g2.getFontMetrics();
		String s;
		g2.setFont(new Font(f.getName(),f.getStyle(),11));
		
		
		// dibujar fondo
		g2.setColor(Color.blue);
		g2.fill(new Rectangle2D.Double(0,0,size.width,size.height));
		
		// dibujar marco
		px=size.width-xOff-yOff;
		
		if(showx==true)
			py=size.height-2*yOff-14;
		else
			py=size.height-2*yOff;
			
		vx=xmax-xmin;
		vy=ymax-ymin;
		

		r=new Rectangle2D.Float(xOff,yOff, px ,py);
		g2.setColor(Color.white);
		g2.draw(r);
		
		g2.drawString(getName(),(size.width-fm.stringWidth(getName()))/2,yOff-5);		
		// dibujar malla
		if(grid==true){
			float dash1[] = {1};
			BasicStroke dashed = new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f, dash1, 10.0f);
			g2.setStroke(dashed);
			// vertical
			t=px/xdiv;
			for(i=0,m=xOff+t;i<xdiv-1;i++,m+=t){
				g2.draw(new Line2D.Float(m ,yOff, m, py+yOff));
			}
			t=py/ydiv;
			// horizontal
			for(i=0,m=yOff+t;i<ydiv-1;i++,m+=t){
				g2.draw(new Line2D.Float(xOff, m, px+xOff, m));
			}
		}
		
		// dibujar escalas
		float r1;

		NumberFormat nf =  NumberFormat.getNumberInstance();
		DecimalFormat er = new DecimalFormat();
		er.setMaximumFractionDigits(3);
		
		if(showx==true){
			t=px/xdiv;
			n=py+yOff+15;
			for(i=1, m=xOff+t, r1=xmin+vx/xdiv+iniXOffset; i<xdiv; i++, r1+=vx/xdiv, m+=t){
				s=er.format(r1);
				g2.drawString(s, m-fm.stringWidth(s)/2, n);
			}
		}
    
		if(showy==true){
			t=py/ydiv;
			for(i=1, m=py+yOff-t, r1=ymin+vy/ydiv; i<ydiv; i++, r1+=vy/ydiv, m-=t){
				s=Float.toString(r1);
				g2.drawString(s,xOff-fm.stringWidth(s),m);
			}
		}
		
		if(datos.size()>0){
			GeneralPath polyline = new GeneralPath(GeneralPath.WIND_EVEN_ODD, datos.size());
			n=ymax*py/vy + yOff;
			t=py/vy;
			Float temp=(Float)datos.getFirst();
			polyline.moveTo(xOff,-temp.floatValue()*t+n);
			
			Iterator it=datos.iterator();
			i=0;
			while(it.hasNext()){
				temp=(Float)it.next();
				polyline.lineTo(i*px/maxdatos+xOff,-temp.floatValue()*t+n);
				i++;
			}
			g2.setStroke(new BasicStroke(1.0f));
			g2.draw(polyline);
		}

	}
}
