//
//  appletMonitor.java
// 
//
//  Created by Miguel Angel Montao Medina on 27/08/05.
//  Copyright (c) 2005 UNAM. All rights reserved.
//  applet monitor de sensores
//

import java.applet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class appletMonitor extends JApplet {
    public void init() {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (UnsupportedLookAndFeelException ex) {
			System.out.println("Unable to load native look and feel");
		}
		catch (Exception exc) {
            System.err.println ("Error loading "+exc);
        }
		getContentPane().setLayout (null);
		
        //Execute a job on the event-dispatching thread:
        //creating this applet's GUI.
        try {
            javax.swing.SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
					String ip=getCodeBase().getHost();
					System.err.println("ip: "+ ip);
					Principal ab = new Principal("Monitor - captura",ip);
					ab.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
					ab.pack();
					ab.setSize(new Dimension(800,500));
					ab.setVisible(true);
                }
            });
        } catch (Exception e) { 
            System.err.println("createGUI didn't successfully complete");
        }
    }
}


class Principal extends JFrame implements ActionListener, WindowListener {
	private Thread hilo;
	private boolean go, conMulti, guardado;
	private Grafica grs[];
	private JPanel der;
    private ConexionMulticast cm=null;
	private ConexionUnicast cu=null;
	private String ip_server;	
	private String interfazRed;
	private File temporalFile;
	private JMenuItem ia, conf, guardar;
	private JLabel prog, estado;
	
	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand()=="ini"){
			iniciar_captura();
		}
		else if(e.getActionCommand()=="fin"){
			detener_captura();
		}
		else if(e.getActionCommand()=="conf"){
			configurar_conexion();
			
		}
		else if(e.getActionCommand()=="guardar"){
			guardar_como();
		}
		else if(e.getActionCommand()=="salir"){
			salir();
			dispose();		
		}
		else if(e.getActionCommand()=="zmas"){
			Dimension dim=der.getSize();
			dim.setSize(dim.getWidth()*1.2,dim.getHeight());
			der.setPreferredSize(dim);
			der.revalidate();
		}
		else if(e.getActionCommand()=="zmen"){
			Dimension dim=der.getSize();
			dim.setSize(dim.getWidth()/1.2,dim.getHeight());
			der.setPreferredSize(dim);
			der.revalidate();
		}
	}
	
	public Principal(String a, String ip){
		super(a);
		go=false;
		guardado=true;
		conMulti=false;
		ip_server=ip;
		try{
			temporalFile=File.createTempFile("muestras", "temp");
			temporalFile.deleteOnExit();
			Enumeration nifs= NetworkInterface.getNetworkInterfaces();
			NetworkInterface netIf= (NetworkInterface)nifs.nextElement();
			interfazRed=netIf.getName();
		}
		catch(Exception se){
			System.err.println(se);
		}
		addWindowListener(this);
		
		JMenuBar menuBar = new JMenuBar();		
		JMenu menu = new JMenu("Sistema");
		menuBar.add(menu);
		ia = new JMenuItem("Iniciar captura");
		ia.addActionListener(this);
		ia.setActionCommand("ini");
		menu.add(ia);
		
		guardar =new JMenuItem("Guardar captura...");
		guardar.setEnabled(false);
		guardar.addActionListener(this);
		guardar.setActionCommand("guardar");
		menu.add(guardar);
		
		conf = new JMenuItem("Configurar conexin");
		conf.addActionListener(this);
		conf.setActionCommand("conf");
		menu.add(conf);
		
		JMenuItem item = new JMenuItem("Salir");
		item.addActionListener(this);
		item.setActionCommand("salir");
		menu.add(item);
		
		setJMenuBar(menuBar);
		grs= new Grafica[4];		
		
		for(int i=0;i<grs.length;i++){
			grs[i]=new Grafica("Sensor "+(i+1));
			grs[i].setVisible(true);
		}
		
		der = new JPanel();
		der.setLayout(new BoxLayout(der,BoxLayout.Y_AXIS));
		for(int i=0;i<grs.length;i++)
			der.add(grs[i]);
		
		JToolBar toolBar = new JToolBar("Still draggable");
		
		JButton button = new JButton("Zoom +");
		button.addActionListener(this);
		button.setActionCommand("zmas");
		toolBar.add(Box.createHorizontalGlue());
		toolBar.add(button);
		
		button=new JButton("Zoom -");
		button.addActionListener(this);
		button.setActionCommand("zmen");
		toolBar.add(button);
		toolBar.setFloatable(false);
		
		JScrollPane scrollPane = new JScrollPane(der);
		estado = new JLabel("Conexin unicast con servidor: "+ip_server);
		prog=new JLabel("");
		
		JPanel abajo=new JPanel();
		abajo.setLayout(new BoxLayout(abajo,BoxLayout.X_AXIS));
		abajo.add(estado);
		abajo.add(Box.createHorizontalGlue());
        abajo.add(prog);
		abajo.add(Box.createHorizontalGlue());
		
		getContentPane().add(toolBar, BorderLayout.PAGE_START);
		getContentPane().add(scrollPane,BorderLayout.CENTER);
		getContentPane().add(abajo,BorderLayout.PAGE_END);
    }

	
	public void windowClosed(WindowEvent e) {}	
    public void windowOpened(WindowEvent e) {}	
	public void windowIconified(WindowEvent e) {}	
    public void windowDeiconified(WindowEvent e) {}	
	public void windowActivated(WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}	
    public void windowClosing(WindowEvent e) {
        salir();
    }
	
	private void guardar_como(){
		boolean archivoSeleccionado=false;
		FileDialog fc=new FileDialog(Principal.this, "Guardar captura como", FileDialog.SAVE);
		fc.setFile("captura.txt");
		fc.show();
		if(fc.getFile()==null)
			return;
		File destino=new File(fc.getDirectory()+fc.getFile());
		try{
			FileReader in = new FileReader(temporalFile);
			FileWriter out = new FileWriter(destino);
			int c;
			while ((c = in.read()) != -1)
				out.write(c);
			in.close();
			out.close();
		}
		catch(IOException io){
			System.err.println("Ocurrio un error al guardar el archivo");
		}
		guardado=true;
		setTitle("Monitor - " + destino.getName());
	}

	
	private void iniciar_captura(){
		go=true;
		ia.setText("Detener captura");
		ia.setActionCommand("fin");
		guardar.setEnabled(false);
		setTitle("Monitor - captura");
		conf.setEnabled(false);
		guardado=false;
		// iniciar la conexion a la red
		if(conMulti){
			cm=new ConexionMulticast(grs,interfazRed,temporalFile);
			cm.iniciar();
		}
		else{
			cu=new ConexionUnicast(grs,ip_server,temporalFile);
			cu.iniciar();
		}
		
		prog.setText("Captura en progreso...");
		
		for(int i=0;i<grs.length;i++){
			grs[i].borrar();
		}	
	}
	
	private void detener_captura(){
		go=false;
		guardar.setEnabled(true);
		conf.setEnabled(true);
		ia.setText("Iniciar captura");
		prog.setText("");
		ia.setActionCommand("ini");	
		prog.setText("Captura finalizada");
		try{
			if(conMulti==true)
				cm.detener();
			else
				cu.detener();
		}
		catch(InterruptedException ie){
			System.err.println(ie);
		}
	}
	
	private void configurar_conexion(){
		Object[] possibilities = {"Unicast", "Multicast"};
		String s = (String)JOptionPane.showInputDialog(this, "Seleccione el tipo de conexin:", "Configuracin", JOptionPane.PLAIN_MESSAGE, null, possibilities, "Unicast");			
		//If a string was returned, say so.
		if ((s != null) && (s.length() > 0)) {
			boolean m;
			if(s=="Multicast"){
				m=true;
				ArrayList interfaces=new ArrayList();
				try { 
					Enumeration nifs= NetworkInterface.getNetworkInterfaces();
					while (nifs.hasMoreElements()) {
						NetworkInterface netIf= (NetworkInterface)nifs.nextElement();
						interfaces.add(netIf.getName());
					} 
				} catch (Exception ex) { 
					System.err.println("Error al listar network interfaces " + ex); 
				}
				interfazRed = (String)JOptionPane.showInputDialog(this,"Seleccione la interfaz de red:",null,JOptionPane.PLAIN_MESSAGE,null,interfaces.toArray(),null);
				estado.setText("Conexin multicast en interfaz: "+interfazRed);					
			}
			else{
				m=false;
				estado.setText("Conexin unicast con servidor: "+ip_server);
			}
			if(m!=conMulti){
				conMulti=m;
			}
			return;
		}
	}
	
	private void salir(){
		if(go==true)
			detener_captura();
		if(guardado==false){
			if(JOptionPane.showConfirmDialog(null,"Desea guardar la captura?")==0)
				guardar_como();
		}
	}
}

class Grafica extends JPanel{
	private JLabel lmin,lmax,lmed;
	public JLabel lact;
	public Display d1;
	private int numdatos;
	private int maxdatos,numdatosdisp;
	private float min, max, ult;
	private int xi=0;
	public Grafica(String a){
		numdatos=0;
		maxdatos=180;
		numdatosdisp=0;
		xi=0;
		setName(a);
        d1=new Display();
		d1.setMaxDatos(maxdatos);
		d1.setPreferredSize(new Dimension(600,150));
		d1.setName(a);
		d1.setAxis(0,180,-20,60,18,8);
		d1.showGrid(true);
		d1.showYAxis(true);
		d1.showXAxis(true);
		
		lmin = new JLabel("Mnimo: 0.0");
        lmax = new JLabel("Mximo: 0.0");
		lmed = new JLabel("ltimo: 0.0");
		lact = new JLabel("Muestra: 0.0");
		
		JPanel eti=new JPanel(); 
		eti.setLayout(new BoxLayout(eti,BoxLayout.X_AXIS));		
        eti.add(lmin);
		eti.add(Box.createHorizontalGlue());
        eti.add(lmax);
		eti.add(Box.createHorizontalGlue());
        eti.add(lmed);
		eti.add(Box.createHorizontalGlue());
        eti.add(lact);
		
		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));		
		add(d1);
		add(eti);
	}
	
	public void borrar(){
		d1.datos.clear();
		numdatos=0;
		numdatosdisp=0;
		xi=0;
	}
	
	public void agregarPunto(Object o){
		Float f=(Float)o;
		ult=f.floatValue();
		if(numdatos==0)
			min=max=ult;
		if(ult<min)
			min=ult;
		if(ult>max)
			max=ult;
		
		d1.datos.add(o);
		numdatos++;
		numdatosdisp++;
		if(numdatosdisp>maxdatos){
			numdatosdisp-=10;
			xi=xi+10;
			for(int i=0;i<10;i++)
				d1.datos.removeFirst();
			d1.setIniXOffset(xi);
		}
		
		lmin.setText("Mnimo: "+min);
        lmax.setText("Mximo: "+max);
		lmed.setText("ltimo: "+ult);
		lact.setText("Muestra: "+numdatos);		
		repaint();
	}
}


class ConexionMulticast implements Runnable {
	private InetAddress     multi_add  = null;
	private MulticastSocket multi_sock = null;
	private Thread hilo;
	private boolean alto;
	private Grafica [] garr=null;
	private BufferedWriter out;
	private int nm;
	public ConexionMulticast(Grafica [] gs, String interfaz, File log){
		garr=gs;
		alto=false;
		nm=0;
		try{
			out = new BufferedWriter(new FileWriter(log));
			multi_sock = new MulticastSocket(12300);
			multi_sock.setSoTimeout(500);
			multi_sock.setNetworkInterface(NetworkInterface.getByName(interfaz));
			multi_add = InetAddress.getByName("239.192.0.1");
			multi_sock.joinGroup(multi_add);
		} 
		catch (IOException ex) {
			System.err.println(ex);
		}
	}
	
	public synchronized void run(){
		Thread thisThread = Thread.currentThread();
        while (hilo == thisThread) {
			try{
				if(alto==true){
					return;
				}
				
				byte[] buf = new byte[256];
				int i,j;
				int k,p;
				float r;
				DatagramPacket packet = new DatagramPacket(buf, buf.length);
				
				multi_sock.receive(packet);
				
				byte[] dt=packet.getData();
				
				String h=new String();
				nm++;
				out.write(Integer.toString(nm));
				for(i=0, j=0;i<4;i++,j+=2){
					p=dt[j]; 
					k=dt[j+1]+50;
					r=(k*100+p);
					r=r/100;
					if(p==-56)
						out.write("\tno");
					else{
						out.write("\t"+Float.toString(r));
						garr[i].agregarPunto(new Float(r));
						garr[i].repaint();
					}
				}
				out.write("\r\n");
				
			}
			catch (SocketTimeoutException se){
			}
			catch (Exception io){
				System.err.println(io);
				return;
			}
		}
	}
	
	public void iniciar() {
		if(hilo==null){
			hilo = new Thread(this);
			hilo.start();
		}
    }
	
    public void detener() throws InterruptedException {
		alto=true;
		hilo.join();
        hilo =null;
		try{
			out.close();
			multi_sock.leaveGroup(multi_add);
		}
		catch(IOException io){
			System.err.println(io);
		}
    }
	
}

class ConexionUnicast implements Runnable {
	private DatagramSocket  uni_sock = null;
	private InetAddress     uni_add  = null;
	private Thread hilo;
	private boolean alto;
	private Grafica [] garr=null;
	private javax.swing.Timer timer;
	private BufferedWriter out;
	private int nm;
	public ConexionUnicast(Grafica [] gs,String ip,File log){
		garr=gs;
		alto=false;
		nm=0;
		try {
			out = new BufferedWriter(new FileWriter(log));
			uni_sock = new DatagramSocket(null);
			uni_sock.setSoTimeout(500);
			uni_add = InetAddress.getByName(ip);
			byte buf[]={55};
			DatagramPacket packet = new DatagramPacket(buf, 1, uni_add, 13068);
			uni_sock.send(packet);
			//Create a timer.
			timer = new javax.swing.Timer(4500, new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					byte buf[]={88};
					try{
						DatagramPacket packet = new DatagramPacket(buf, 1, uni_add, 13068);
						uni_sock.send(packet);
					}
					catch (IOException io){
						System.err.println(io);
						return;
					}
				}
			});
			timer.start();
		} 
		catch (IOException ex) {
			System.err.println(ex);
		}
	}
	
	public void run(){
		Thread thisThread = Thread.currentThread();


        while (hilo == thisThread) {
			try{
				
				if(alto==true){
					timer.stop();
					return;
				}
				byte[] buf = new byte[256];
				int i,j;
				int k,p;
				float r;
				DatagramPacket packet = new DatagramPacket(buf, buf.length);
				
				uni_sock.receive(packet);
				
				byte[] dt=packet.getData();
				
				nm++;
				out.write(Integer.toString(nm));

				for(i=0, j=0;i<4;i++,j+=2){
					p=dt[j]; 
					k=dt[j+1]+50;
					r=(k*100+p);
					r=r/100;
					if(p==-56)
						out.write("\tno");
					else{
						out.write("\t"+Float.toString(r));
						garr[i].agregarPunto(new Float(r));
						garr[i].repaint();
					}
				}
				out.write("\r\n");
			}
			catch (SocketTimeoutException se){
			}
			catch (Exception io){
				System.err.println(io);
				return;
			}
		}
	}
	
	public void iniciar() {
		if(hilo==null){
			hilo = new Thread(this);
			hilo.start();
		}
    }
	
    public void detener() throws InterruptedException {
		alto=true;
		hilo.join();
		hilo =null;
		byte buf[]={33}; // cualquier cosa != 55 para detener el trafico udp
		DatagramPacket packet = new DatagramPacket(buf, 1, uni_add, 13068);
		try{
			out.close();
			uni_sock.send(packet);		
		}
		catch(IOException io){
			System.err.println(io);
		}
    }
	
}
