/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/


int1 feof;
typedef struct {
   int16 tam;  // tamano en bytes del archivo
   int16 ap;   // offset al contenido del archivo (donde voy)
   int16 dini; // direccion de inicio del archivo en la eeprom
   int8  tipo;  // tipo de archivo (binario, texto, gzip)
   int8  mime; // tipo mime del archivo (content-type)
} freg;

freg factual;

int8 fopen(char *archivo){
   int8 total_archivos,i,j;
   char tmp[27];
   char *t;
   // abrir el flujo desde la dir 0x0 y preparar para lectura
   i2c_start();
   i2c_write(0xa0);
   i2c_write(0);
   i2c_write(0);
   i2c_start();
   i2c_write(0xa1);
   total_archivos=i2c_read();
   for(i=0;i<total_archivos;i++){
      for(j=0,t=tmp;j<27;j++,t++){
         *t=i2c_read();
      }
      if(strcmp(tmp,archivo)==0){
         factual.dini=make16(tmp[21],tmp[22]);
         factual.tam=make16(tmp[23],tmp[24]);
         factual.ap=0;
         factual.tipo=tmp[25];
         factual.mime=tmp[26];
         i2c_read(0);
         i2c_stop();
         // abrir el flujo desde la dir del archivo solicitado y prep. lectura
         feof=0;
         i2c_start();
         i2c_write(0xa0);
         i2c_write(tmp[21]);
         i2c_write(tmp[22]);
         i2c_start();
         i2c_write(0xa1);
         return 0;
      }
   }
   // no se encontro el archivo solicitado
   // cerrar el flujo
   factual=0;
   i2c_read(0);
   i2c_stop();
   return 1;
}

void freopen(void){
   // abrir el flujo desde la dir del archivo solicitado y prep. lectura
   int16 tmp;
   feof=0;
   i2c_start();
   i2c_write(0xa0);
   tmp=factual.dini+factual.ap;
   i2c_write(make8(tmp,1));
   i2c_write(make8(tmp,0));
   i2c_start();
   i2c_write(0xa1);
}

int16 fread(char *bufer, int16 num_bytes){
   int16 i;
   if(!(factual.tam-factual.ap>num_bytes)){ // solo leer los bytes disponibles
      num_bytes=factual.tam-factual.ap;
      feof=1;
   }
   for(i=0;i<num_bytes;i++,bufer++){
      *bufer=i2c_read();
   }
   factual.ap+=num_bytes;
   return num_bytes;
}

int16 freadtoken(char *bufer, char token, char *parm,int16 lim){
   int16 i;
   char b;
   for(i=0;(factual.ap<factual.tam)&&(i<lim);i++,bufer++,factual.ap++){
      b=i2c_read();
      if(b == '@'){
         *parm=i2c_read();
         factual.ap+=2;
         break;
      }
      *bufer=b;
   }
   if(factual.ap == factual.tam)
      feof=1;
   return i;
}


void fclose(){
   i2c_read(0);
   i2c_stop();
}
