/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#ifndef _ARP_C_
#define _ARP_C_

#include "uinet/ethernet.h"
#include "util.c"
#include "uinet/ip.h"

//******************************************************************
//*	Cabecera ARP
//******************************************************************
#define	arp_hwtype			   0x0E
#define	arp_prtype			   0x10
#define	arp_hwlen			   0x12
#define	arp_prlen			   0x13
#define	arp_op				   0x14
#define	arp_shaddr			   0x16   //arp mac fuente
#define	arp_sipaddr			   0x1C   //arp ip fuente
#define	arp_thaddr			   0x20   //arp mac destino
#define	arp_tipaddr			   0x26   //arp ip destino


#define es_arp             packet[enetpacketType0] == 0x08 && packet[enetpacketType1] == 0x06
#define es_respuesta_arp   packet[arp_hwtype+1] == 0x01 && \
                           packet[arp_prtype] == 0x08 && packet[arp_prtype+1] == 0x00 && \
                           packet[arp_hwlen] == 0x06 && packet[arp_prlen] == 0x04 && \
                           packet[arp_op+1] == 0x02 && \
                           MYIP[0] == packet[arp_tipaddr] && MYIP[1] == packet[arp_tipaddr+1] && \
                           MYIP[2] == packet[arp_tipaddr+2] &&  MYIP[3] == packet[arp_tipaddr+3]

#define es_peticion_arp    packet[arp_hwtype+1] == 0x01 && \
                           packet[arp_prtype] == 0x08 && packet[arp_prtype+1] == 0x00 && \
                           packet[arp_hwlen] == 0x06 && packet[arp_prlen] == 0x04 && \
                           packet[arp_op+1] == 0x01 && \
                           MYIP[0] == packet[arp_tipaddr] && MYIP[1] == packet[arp_tipaddr+1] && \
                           MYIP[2] == packet[arp_tipaddr+2] &&  MYIP[3] == packet[arp_tipaddr+3]


uint t_mac[6];
uint t_ip[4];
uint arp_resp;
uint arp_fuera;
int1 ARP_PET;

// Enviar mi direccion MAC a quien lo requiera
void arp_env_mac(){
   //write destination MAC address
   packet[enetpacketDest0]=packet[enetpacketSrc0];
   packet[enetpacketDest1]=packet[enetpacketSrc1];
   packet[enetpacketDest2]=packet[enetpacketSrc2];
   packet[enetpacketDest3]=packet[enetpacketSrc3];
   packet[enetpacketDest4]=packet[enetpacketSrc4];
   packet[enetpacketDest5]=packet[enetpacketSrc5];
   //write source MAC address
   packet[enetpacketSrc0]=MAC_ADDR_0;
   packet[enetpacketSrc1]=MAC_ADDR_1;
   packet[enetpacketSrc2]=MAC_ADDR_2;
   packet[enetpacketSrc3]=MAC_ADDR_3;
   packet[enetpacketSrc4]=MAC_ADDR_4;
   packet[enetpacketSrc5]=MAC_ADDR_5;

   //write typelen hwtype prtype hwlen prlen op:
   packet[arp_op+1] = 2;

   //write remote MAC address
   packet[arp_thaddr+0]=packet[enetpacketDest0];
   packet[arp_thaddr+1]=packet[enetpacketDest1];
   packet[arp_thaddr+2]=packet[enetpacketDest2];
   packet[arp_thaddr+3]=packet[enetpacketDest3];
   packet[arp_thaddr+4]=packet[enetpacketDest4];
   packet[arp_thaddr+5]=packet[enetpacketDest5];

   //remote IP address
   packet[arp_tipaddr+0]=packet[arp_sipaddr+0];
   packet[arp_tipaddr+1]=packet[arp_sipaddr+1];
   packet[arp_tipaddr+2]=packet[arp_sipaddr+2];
   packet[arp_tipaddr+3]=packet[arp_sipaddr+3];

   //write ethernet module IP address
   packet[arp_sipaddr+0]=MYIP[0];
   packet[arp_sipaddr+1]=MYIP[1];
   packet[arp_sipaddr+2]=MYIP[2];
   packet[arp_sipaddr+3]=MYIP[3];

   //write ethernet module MAC address
   packet[arp_shaddr+0]=MAC_ADDR_0;
   packet[arp_shaddr+1]=MAC_ADDR_1;
   packet[arp_shaddr+2]=MAC_ADDR_2;
   packet[arp_shaddr+3]=MAC_ADDR_3;
   packet[arp_shaddr+4]=MAC_ADDR_4;
   packet[arp_shaddr+5]=MAC_ADDR_5;

   nic_putd(packet,packet_len);
 }

// Solicitar la mac de tip, usando MYIP como origen
void arp_sol_mac_tip(){
   arp_resp=0;
   arp_fuera=c_tiempo+30;  // segundo y medio
   //write destination MAC address
   packet[enetpacketDest0]=0xff;
   packet[enetpacketDest1]=0xff;
   packet[enetpacketDest2]=0xff;
   packet[enetpacketDest3]=0xff;
   packet[enetpacketDest4]=0xff;
   packet[enetpacketDest5]=0xff;
   //write source MAC address
   packet[enetpacketSrc0]=MAC_ADDR_0;
   packet[enetpacketSrc1]=MAC_ADDR_1;
   packet[enetpacketSrc2]=MAC_ADDR_2;
   packet[enetpacketSrc3]=MAC_ADDR_3;
   packet[enetpacketSrc4]=MAC_ADDR_4;
   packet[enetpacketSrc5]=MAC_ADDR_5;
   packet[enetpacketType0]=0x8;
   packet[enetpacketType1]=0x6;

   packet[arp_hwtype]=0;
   packet[arp_hwtype+1]=1;
   packet[arp_prtype]=0x8;
   packet[arp_prtype+1]=0;
   packet[arp_hwlen]=0x6;
   packet[arp_prlen]=0x4;
   packet[arp_op]=0;
   packet[arp_op+1]=1;

   //write ethernet module IP address
   packet[arp_sipaddr]  =MYIP[0];
   packet[arp_sipaddr+1]=MYIP[1];
   packet[arp_sipaddr+2]=MYIP[2];
   packet[arp_sipaddr+3]=MYIP[3];

   //write ethernet module MAC address
   packet[arp_shaddr]  =MAC_ADDR_0;
   packet[arp_shaddr+1]=MAC_ADDR_1;
   packet[arp_shaddr+2]=MAC_ADDR_2;
   packet[arp_shaddr+3]=MAC_ADDR_3;
   packet[arp_shaddr+4]=MAC_ADDR_4;
   packet[arp_shaddr+5]=MAC_ADDR_5;

   //write remote MAC address
   packet[arp_thaddr]  =0;
   packet[arp_thaddr+1]=0;
   packet[arp_thaddr+2]=0;
   packet[arp_thaddr+3]=0;
   packet[arp_thaddr+4]=0;
   packet[arp_thaddr+5]=0;

   //remote IP address
   packet[arp_tipaddr+0]=t_ip[0];
   packet[arp_tipaddr+1]=t_ip[1];
   packet[arp_tipaddr+2]=t_ip[2];
   packet[arp_tipaddr+3]=t_ip[3];

   nic_putd(packet,42);
 }

uint arp_buscar_MYIP(){
   uint i;
   uint t_ini;
   i=0;
   t_ini=c_tiempo+5; // 500ms
   t_ip[0]=MYIP[0];
   t_ip[1]=MYIP[1];
   t_ip[2]=MYIP[2];
   t_ip[3]=MYIP[3];
   for(;;){
      restart_wdt();
      if(t_ini<=c_tiempo){
         t_ini=c_tiempo+7; // 700ms
         i++;
         if(i<3)
            arp_sol_mac_tip();
         else{ // intente 5 veces y nadie respondio,
            return 0;      // asumo que nadie usa MYIP
         }
      }
      packet_len=nic_begin_packet_rx();
      if(packet_len>0){
         nic_packet_get_data(packet,packet_len);
         nic_end_packet_rx();
         if(es_arp)
            if(es_respuesta_arp){
               for(i=0;i<6;i++)
                  t_mac[i]=packet[arp_shaddr+i];
               return 1;
            }
      }
   }
}


uint arp_init(){
   uint c;
   uint r=0;
buscar_ip:
   printf("\r\nConfigurando IP...");
   c=arp_buscar_MYIP();
   if(c==0){
      printf("\r\nok!");
      printf("\r\nMi IP es: %u.%u.%u.%u",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);
      output_bit(PIN_A5,0);
      return r;
   }
   else{
      r=1;
      output_bit(PIN_A5,1);
      printf("\r\nLa ip: %u.%u.%u.%u",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);
      printf(" en uso por: %x %x %x %x %x %x",t_mac[0],t_mac[1],t_mac[2],t_mac[3],t_mac[4],t_mac[5]);
capturar_ip:
      printf("\r\nIngrese nueva ip(x.x.x.x): ");
      MYIP[0]=leer_uint('.');
      MYIP[1]=leer_uint('.');
      MYIP[2]=leer_uint('.');
      MYIP[3]=leer_uint('\r');
      printf("\r\nUsar ip: %u.%u.%u.%u ?[S/n] ",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);
      c=getch();
      putchar(c);

      if(c=='n')
         goto capturar_ip;
      goto buscar_ip;
   }
}


#endif
