/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#ifndef _IP_C_
#define _IP_C_

#include "uinet/ip.h"

#define es_ip                 (packet[enetpacketType0] == 0x08 && packet[enetpacketType1] == 0x00)

#define es_mi_ip              (packet[ip_destaddr]   == MYIP[0] && \
                               packet[ip_destaddr+1] == MYIP[1] && \
                               packet[ip_destaddr+2] == MYIP[2] && \
                               packet[ip_destaddr+3] == MYIP[3])

#define es_all_systems        (packet[ip_destaddr]   == all_systems_mcip0 && \
                               packet[ip_destaddr+1] == all_systems_mcip1 && \
                               packet[ip_destaddr+2] == all_systems_mcip2 && \
                               packet[ip_destaddr+3] == all_systems_mcip3)

#define es_mi_grp             (packet[ip_destaddr]   == MCIP[0] && \
                               packet[ip_destaddr+1] == MCIP[1] && \
                               packet[ip_destaddr+2] == MCIP[2] && \
                               packet[ip_destaddr+3] == MCIP[3])


uint16 cksum(int8 *addr,uint16 len){
	int8 ipcksum_b,ipcksum_h,ipcksum_l;
#asm
	clrf	ipcksum_b
	clrf	ipcksum_h
	clrf	ipcksum_l
  	movf	addr,w
   movwf   0xFE1
	movf    (&addr+1),w
   movwf   0xFE2
otro:
	MOVF   len,W
	IORWF  (&len+1),W
	BZ     l3

	movf	0xfe6,w
   incf   	ipcksum_b,f
   btfss  	ipcksum_b,0
   goto  	l1

   addwf	ipcksum_h,f
	btfsc	0xfd8,0
   incfsz  ipcksum_l,f
   goto	l2
   incf	ipcksum_h,f
   goto	l2
l1:
   addwf	ipcksum_l,f
	btfsc	0xfd8,0
   incfsz  ipcksum_h,f
   goto	l2
   incf	ipcksum_l,f
l2:
	MOVF   len,W
	BTFSC  0xFD8,2
	DECF   (&len+1),F
	DECF   len,F
	BRA    otro
l3:
 	comf    ipcksum_h,f
  	comf    ipcksum_l,f
#endasm
   return make16(ipcksum_h,ipcksum_l);
}

void ip(uint protocolo, uint16 num_datos, uint ttl, uint *ap_IP, uint *ap_MAC)
{
   uint16 chksum16;
   uint l_cabecera;

   packet[ip_destaddr]  =ap_IP[0];
   packet[ip_destaddr+1]=ap_IP[1];
   packet[ip_destaddr+2]=ap_IP[2];
   packet[ip_destaddr+3]=ap_IP[3];

   packet[ip_srcaddr]=MYIP[0];
   packet[ip_srcaddr+1]=MYIP[1];
   packet[ip_srcaddr+2]=MYIP[2];
   packet[ip_srcaddr+3]=MYIP[3];

   if(protocolo==PROT_IGMP){
      packet[ip_vers_len]=0x46;
      num_datos+=24; // 24 bytes cabecera IP
      packet[ip_data]=0x94;   //IP option router alert
      packet[ip_data+1]=0x4;  //
      packet[ip_data+2]=0;    //
      packet[ip_data+3]=0;    //
      l_cabecera=24;
   }
   else{
      packet[ip_vers_len]=0x45;
      num_datos+=20; // 20 bytes cabecera IP
      l_cabecera=20;
   }

   packet[ip_tos]=0;

   packet[ip_pktlen]=make8(num_datos,1);
   packet[ip_pktlen+1]=make8(num_datos,0);

   packet[ip_id]=make8(ip_id_num,1);
   packet[ip_id+1]=make8(ip_id_num,0);
   ip_id_num++;

   packet[ip_frag_offset]=0x40;
   packet[ip_frag_offset+1]=0;

   packet[ip_ttl]=ttl;
   packet[ip_proto]=protocolo;// PROT_TCP, PROT_UDP

   packet[ip_hdr_cksum]=0x00;
   packet[ip_hdr_cksum+1]=0x00;

   chksum16=cksum(&packet[ip_vers_len],l_cabecera);

   packet[ip_hdr_cksum] = make8(chksum16,1);
   packet[ip_hdr_cksum+1] = make8(chksum16,0);

   if(ap_MAC!=NULL){
      packet[enetpacketDest0]=ap_MAC[0];
      packet[enetpacketDest1]=ap_MAC[1];
      packet[enetpacketDest2]=ap_MAC[2];
      packet[enetpacketDest3]=ap_MAC[3];
      packet[enetpacketDest4]=ap_MAC[4];
      packet[enetpacketDest5]=ap_MAC[5];
   }
   else{
      packet[enetpacketDest0]=1;
      packet[enetpacketDest1]=0;
      packet[enetpacketDest2]=0X5E;
      packet[enetpacketDest3]=ap_IP[1]&0x7f;
      packet[enetpacketDest4]=ap_IP[2];
      packet[enetpacketDest5]=ap_IP[3];
   }

   packet[enetpacketSrc0]=MAC_ADDR_0;
   packet[enetpacketSrc1]=MAC_ADDR_1;
   packet[enetpacketSrc2]=MAC_ADDR_2;
   packet[enetpacketSrc3]=MAC_ADDR_3;
   packet[enetpacketSrc4]=MAC_ADDR_4;
   packet[enetpacketSrc5]=MAC_ADDR_5;

   packet[enetpacketType0]=0x8;
   packet[enetpacketType1]=0x0;

   nic_putd(packet,num_datos+14); // 14 de ethernet
}

//******************************************************************
//*	Perform ICMP Function
//*   This routine responds to a ping.
//******************************************************************

void icmp()
{
   uint16 len,chksum16;
   //set echo reply
   packet[ICMP_type]=0x00;

   //clear the ICMP checksum
   packet[ICMP_cksum ]=0x00;
   packet[ICMP_cksum+1]=0x00;

   //setup the IP header
   packet[ip_destaddr]=packet[ip_srcaddr];
   packet[ip_destaddr+1]=packet[ip_srcaddr+1];
   packet[ip_destaddr+2]=packet[ip_srcaddr+2];
   packet[ip_destaddr+3]=packet[ip_srcaddr+3];

   packet[ip_srcaddr]=MYIP[0];
   packet[ip_srcaddr+1]=MYIP[1];
   packet[ip_srcaddr+2]=MYIP[2];
   packet[ip_srcaddr+3]=MYIP[3];

   packet[enetpacketDest0]=packet[enetpacketSrc0];
   packet[enetpacketDest1]=packet[enetpacketSrc1];
   packet[enetpacketDest2]=packet[enetpacketSrc2];
   packet[enetpacketDest3]=packet[enetpacketSrc3];
   packet[enetpacketDest4]=packet[enetpacketSrc4];
   packet[enetpacketDest5]=packet[enetpacketSrc5];

   packet[enetpacketSrc0]=MAC_ADDR_0;
   packet[enetpacketSrc1]=MAC_ADDR_1;
   packet[enetpacketSrc2]=MAC_ADDR_2;
   packet[enetpacketSrc3]=MAC_ADDR_3;
   packet[enetpacketSrc4]=MAC_ADDR_4;
   packet[enetpacketSrc5]=MAC_ADDR_5;

   //calculate the ICMP checksum

   len = (make16(packet[ip_pktlen],packet[ip_pktlen+1])) - 20;
   chksum16=cksum(&packet[ICMP_type],len);
   packet[ICMP_cksum] = make8(chksum16,1);
   packet[ICMP_cksum+1] = make8(chksum16,0);
   //send the ICMP packet along on its way
   len = make16(packet[ip_pktlen],packet[ip_pktlen+1]);
   nic_putd(packet,len+14);
}


void igmp_report(){
   uint16 chksum16;
   // el +4 es para dejar el espacio de la opcion ip router alert
   packet[IGMP_ver_type+4]=0x16;
   packet[IGMP_mrt+4]=0;
   packet[IGMP_cksum+4]=0;
   packet[IGMP_cksum+1+4]=0;

   packet[IGMP_group+4]=MCIP[0];
   packet[IGMP_group+1+4]=MCIP[1];
   packet[IGMP_group+2+4]=MCIP[2];
   packet[IGMP_group+3+4]=MCIP[3];

   chksum16=cksum(&packet[IGMP_ver_type+4],8);
   packet[IGMP_cksum+4]=make8(chksum16,1);
   packet[IGMP_cksum+1+4]=make8(chksum16,0);;

   ip(PROT_IGMP,8,1,MCIP,NULL);
}


void igmp_leave(){
   uint16 chksum16;
   uint tip[4];

   tip[0]=leave_group_ip0;
   tip[1]=leave_group_ip1;
   tip[2]=leave_group_ip2;
   tip[3]=leave_group_ip3;

   packet[IGMP_ver_type]=0x17;
   packet[IGMP_ver_type+1]=0;
   packet[IGMP_cksum]=0;
   packet[IGMP_cksum+1]=0;

   packet[IGMP_group]=MCIP[0];
   packet[IGMP_group+1]=MCIP[1];
   packet[IGMP_group+2]=MCIP[2];
   packet[IGMP_group+3]=MCIP[3];

   chksum16=cksum(&packet[IGMP_ver_type],8);
   packet[IGMP_cksum]=make8(chksum16,1);
   packet[IGMP_cksum+1]=make8(chksum16,0);;

   ip(PROT_IGMP,8,1,tip,NULL);
}


/*uint16 cksum(char *addr,uint16 len)
{
   uint data_H,data_L;
   uint32 sum=0;
        while(len > 1)
      {
         data_H=*addr++;
         data_L=*addr++;
         sum = sum + make16(data_H,data_L);
         len -=2;
      }
      if(len > 0)
      {
         data_H=*addr;
         data_L=0x00;
         sum = sum + make16(data_H,data_L);
      }
      while(sum>>16)
         sum=(sum & 0xFFFF) + (sum>>16);

      data_H=make8(sum,1);
      data_L=make8(sum,0);

      return ~make16(data_H,data_L);
}*/

#endif

