/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#ifndef _IP_H_
#define _IP_H_

//******************************************************************
//*	Cabecera IP
//******************************************************************
#define	ip_vers_len			   0x0E
#define	ip_tos				   0x0F
#define	ip_pktlen			   0x10
#define	ip_id				      0x12
#define	ip_frag_offset			0x14
#define	ip_ttl				   0x16
#define	ip_proto			      0x17
#define	ip_hdr_cksum			0x18
#define	ip_srcaddr			   0x1A
#define	ip_destaddr			   0x1E
#define	ip_data				   0x22


//******************************************************************
//*	Cabecera ICMP
//******************************************************************
#define	ICMP_type			   ip_data
#define	ICMP_code			   ICMP_type+1
#define	ICMP_cksum			   ICMP_code+1
#define	ICMP_id				   ICMP_cksum+2
#define	ICMP_seqnum			   ICMP_id+2
#define  ICMP_data            ICMP_seqnum+2

//******************************************************************
//*	Cabecera IGMP V2
//******************************************************************

#define	IGMP_ver_type		   ip_data
#define  IGMP_mrt             IGMP_ver_type+1
#define	IGMP_cksum			   IGMP_ver_type+2
#define  IGMP_group           IGMP_ver_type+4

#define  leave_group_ip0      224
#define  leave_group_ip1      0
#define  leave_group_ip2      0
#define  leave_group_ip3      2

#define  all_systems_mcip0    224
#define  all_systems_mcip1    0
#define  all_systems_mcip2    0
#define  all_systems_mcip3    1


//******************************************************************
// Protocolos IP
//******************************************************************
#define	PROT_ICMP			   0x01
#define  PROT_IGMP            0x02
#define	PROT_TCP			      0x06
#define	PROT_UDP			      0x11

//******************************************************************
// Variables IP
//******************************************************************
uint16 ip_id_num;    // identificador
uint MYIP[4];        // direccion IP
uint MCIP[4];        // direccion IP grupo multicast
uint ttl_mc;         // ttl para multicast
int1  IGMP_REPORT;   // bandera para disparar un membership report
uint  igmp_fuera;    // tiempo para disparar el membership report
#endif
