/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#ifndef _TCP_H_
#define _TCP_H_

//******************************************************************
//*	Cabecera TCP
//******************************************************************
#define	TCP_srcport			   0x22
#define	TCP_destport   	   0x24
#define	TCP_seqnum  	      0x26
#define	TCP_acknum	         0x2A
#define	TCP_hdrflags			0x2E
#define	TCP_window			   0x30
#define	TCP_cksum		      0x32
#define	TCP_urgentptr   		0x34
#define  TCP_data             0x36

//******************************************************************
//*	Banderas TCP
//******************************************************************

#define  FIN   0x01
#define  SYN   0x02
#define  RST   0x04
#define  PSH   0x08
#define  ACK   0x10
#define  URG   0x20

//******************************************************************
//*	Pseudo-cabecera
//******************************************************************
#ifndef  PSEUDO_SA
#define  PSEUDO_ZERO 0x16
#define  PSEUDO_PTCL 0X17
#define  PSEUDO_LEN  0X18
#define  PSEUDO_SA   0X1A
#define  PSEUDO_DA   0X1E
#endif


//******************************************************************
// TCB
//******************************************************************
typedef struct {
   uint  id;      // mi identificador
   uint  ip[4];   // ip de mi cliente
   uint  pto[2];  // puerto de mi cliente
   uint  mac[6];  // direccion mac de mi cliente
   uint16 MSS;    // el MSS de mi cliente
   uint  estado;  // estado actual tcp
   uint32 sndnxt, rcvnxt;  // numero de secuencia y acknowledge
   uint16 lude;   // numero de datos que mande en el ultimo paquete
   uint sa;     // estimadores
   uint sv;     // estimadores
   uint tempo;  // rtt
   uint rto;    // el tiempo fuera para una retransmision
   uint nrtx;   // el numero de retransmisiones que llevo del paquete
} tcb ;

//******************************************************************
// Variables
//******************************************************************

tcb clientes[MAX_CLIENTES];

tcb *cnte;
uint32 ini_seqnum;
uint* tcp_buf;
uint tcp_activas;
uint MY_PORT_ADDRESS_H, MY_PORT_ADDRESS_L;
//******************************************************************
// Prototipos de funciones
//******************************************************************
void tcp_init();
sint tcp_conectar();
void tcp_enviar(uint flags, uint16 num_datos);
void tcp_env_reset();
void tcp();
void tcp_rtx();
void udp_enviar(uint16 num_datos);

//******************************************************************
// Prototipos de funciones
//******************************************************************
void ev_tcp_ini();
void ev_tcp_fin();
void ev_tcp_rtx();
sint ev_tcp_psh();
sint ev_tcp_ack();

#endif
