/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#ifndef _UDP_C_
#define _UDP_C_
//******************************************************************
//*	UDP Header
//;******************************************************************
#define	UDP_srcport			   ip_data
#define	UDP_destport			UDP_srcport+2
#define	UDP_len				   UDP_destport+2
#define	UDP_cksum			   UDP_len+2
#define	UDP_data			      UDP_cksum+2


//******************************************************************
//*	Pseudo-cabecera
//******************************************************************
#ifndef  PSEUDO_SA
#define  PSEUDO_ZERO 0x16
#define  PSEUDO_PTCL 0X17
#define  PSEUDO_LEN  0X18
#define  PSEUDO_SA   0X1A
#define  PSEUDO_DA   0X1E
#endif

#define MULTICAST 0x1
#define UNICAST   0x2


uint pto_udp_h, pto_udp_l;
uint pto_mc_h,  pto_mc_l;

typedef struct {
   uint ip[4];
   uint pto[2];
   uint mac[6];
} cliente_udp;

cliente_udp cnte_udp;

int1  usr_udp;
uint  udp_fuera;
char *udp_buf;



void udp(){
   udp_buf=&packet[UDP_data];
   if(packet[UDP_destport]==pto_udp_h && packet[UDP_destport+1]==pto_udp_l){
      switch(*udp_buf){
      case 55:
         cnte_udp.mac[0]=packet[enetpacketSrc0];
         cnte_udp.mac[1]=packet[enetpacketSrc1];
         cnte_udp.mac[2]=packet[enetpacketSrc2];
         cnte_udp.mac[3]=packet[enetpacketSrc3];
         cnte_udp.mac[4]=packet[enetpacketSrc4];
         cnte_udp.mac[5]=packet[enetpacketSrc5];
         cnte_udp.ip[0]=packet[ip_srcaddr];
         cnte_udp.ip[1]=packet[ip_srcaddr+1];
         cnte_udp.ip[2]=packet[ip_srcaddr+2];
         cnte_udp.ip[3]=packet[ip_srcaddr+3];
         cnte_udp.pto[0]=packet[UDP_srcport];
         cnte_udp.pto[1]=packet[UDP_srcport+1];
      case 88:
         udp_fuera=c_tiempo+50;
         usr_udp=1;
         break;
      case 33:
         usr_udp=0;
         break;
      default:
      }
   }
   else{
   }
}

void udp_enviar(uint16 num_datos,uint uni_multi){
   uint16 chksum16;
   uint *apip;
   uint *apmac;
   uint ttl;

   packet[UDP_srcport]    = pto_udp_h;
   packet[UDP_srcport+1]  = pto_udp_l;

   num_datos+=8;

   packet[UDP_len] = make8(num_datos,1);
   packet[UDP_len+1] = make8(num_datos,0);
   packet[UDP_cksum]    = 0;
   packet[UDP_cksum+1]  = 0;

   packet[PSEUDO_ZERO]=0x00;
   packet[PSEUDO_PTCL]=PROT_UDP;
   packet[PSEUDO_LEN]=make8(num_datos,1);
   packet[PSEUDO_LEN+1]=make8(num_datos,0);

   packet[ip_srcaddr]  =MYIP[0];
   packet[ip_srcaddr+1]=MYIP[1];
   packet[ip_srcaddr+2]=MYIP[2];
   packet[ip_srcaddr+3]=MYIP[3];

   if(uni_multi == MULTICAST){
      packet[UDP_destport]   = pto_mc_h;
      packet[UDP_destport+1] = pto_mc_l;

      packet[ip_destaddr]  =MCIP[0];
      packet[ip_destaddr+1]=MCIP[1];;
      packet[ip_destaddr+2]=MCIP[2];
      packet[ip_destaddr+3]=MCIP[3];
   }
   else{
      packet[UDP_destport]   = cnte_udp.pto[0];
      packet[UDP_destport+1] = cnte_udp.pto[1];

      packet[ip_destaddr]  =cnte_udp.ip[0];
      packet[ip_destaddr+1]=cnte_udp.ip[1];;
      packet[ip_destaddr+2]=cnte_udp.ip[2];
      packet[ip_destaddr+3]=cnte_udp.ip[3];
   }

   chksum16=cksum(&packet[PSEUDO_ZERO],num_datos+12);

   if(chksum16==0)
      chksum16=0xffff;

   packet[UDP_cksum] = make8(chksum16,1);
   packet[UDP_cksum+1] = make8(chksum16,0);

   if(uni_multi == MULTICAST){
      ttl=ttl_mc;
      apip=&MCIP[0];
      apmac=NULL;
   }
   else{
      ttl=0x80;
      apip=&cnte_udp.ip[0];
      apmac=&cnte_udp.mac[0];
   }

   ip(PROT_UDP,num_datos,ttl, apip, apmac);
}

#endif
