/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#include "crc.c"  // incluido en el compilador PIC CCS
#define XEOT 0x04
#define XACK 0x06
#define XNAK 0x15


int16 dir;

int getbytes(char *dest, int num){
   uint t_ini;
   t_ini=c_tiempo+30; // 3 segundos
   while(num!=0 && t_ini!=c_tiempo){
      if(kbhit()){
         *dest=getc();
         dest++;
         num--;
      }
   }
   if(num==0)
      return 0;
   else
      return 1;
}

void programar_eeprom(){
   int ack,i;
   char *bufer;
   output_bit(PIN_A5,1);
   bufer=packet;
   ack=1;
   while(ack==1){ // esperar hasta que termine de programar y este lista
      i2c_start();
      ack=i2c_write(0xa0);
   }
   i2c_write(dir>>8);
   i2c_write(dir);
   for(i=0; i<128; i++)
      i2c_write(bufer[3+i]);
   i2c_stop();
   dir+=128;
   output_bit(PIN_A5,0);
}

int xmodem_recv(){
   int i,fin,sec,fallas;
   int16 crc,tmp;
   char *bufer;
   bufer=packet;
   fallas=0;

   while(1){
      tmp=c_tiempo+30; // 3 segundos
      while(!kbhit()&& tmp!=c_tiempo);
      if(kbhit())
         break;
      else
         putchar('C');
   }
   fin=0;
   sec=1;

   dir=0;

   while(!fin){
      if(fallas==5){
         return 1;
      }
      i=getbytes(bufer,133);
      if(i){ // tiempo fuera
         if(bufer[0]==XEOT){ // fin de transmision
            putchar(XACK);
            fin=1;
         }
         else{
            putchar(XNAK);
            fallas++;
         }
      }
      else{ // bufer con datos
         if(sec==bufer[1]&&~sec==bufer[2]){ // numero de secuencia correcto?
            tmp=make16(bufer[131],bufer[132]);
            crc=generate_16bit_crc(&bufer[3],128,CRC_CCITT);
            if(crc==tmp){                   // crc correcto?
               sec++;                       // paquete ok!
               programar_eeprom();
               putchar(XACK);
            }
            else{
               putchar(XNAK);
               fallas++;
            }
         }
         else{
            if(sec>bufer[1]) // paquete duplicado
               putchar(XACK);
               fallas++;
         }
      }
   }
   return 0;
}
