/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/


#ifndef _HTTP_C_
#define _HTTP_C_

int8 ii;

#define cstcpy(a,b)  for(ii=0;ii<sizeof(b)-1;ii++,a++) *a=b[ii];

//#define HTTP_DEBUG

#define HTTP_CERRAR  0x01  // cerrar conexion al termino de transmision
#define HTTP_RSTCPU  0x02  // resetear CPU en fin_aplicacion
#define HTTP_ENVARCH 0x04  // estoy enviando archivo?
#define HTTP_ADMIN   0x08  // el usuario esta configurando el servidor

#define HTTP_MAX_ALIVE 50

typedef struct {
   char dia;
   char dsem;
   char ano;
   char mes;
   char hora;
   char min;
   char seg;
} tiempo;

typedef struct {
   uint tkeepalive;  // contador de tiempo de vida
   uint contenido:4; // tipo de contenido generado en ult peticion
   uint resp:4;      // codigo de respuesta env en ult peticion
   uint flags;       // banderas
   uint npaq;        // cuantos paquetes se han enviado de la respuesta
   freg archivo;     // el archivo que estoy enviando
   tiempo tstamp;    // registro de tiempo
} web;

web usuarios[MAX_CLIENTES];
web *usr;

static int8 chunk=0;

uint tpto_L,tpto_H;

// archivos forzosos
char p0[]="index.html"; // indice
char p1[]="404.html";   // Not found
char p2[]="501.html";   // Not implemented
char p3[]="hora.egi";
char p4[]="dir.egi";
char p5[]="ndir.egi";

const char r0[]="HTTP/1.1 404 Not Found\r\n";
const char r1[]="HTTP/1.1 501 Not Implemented\r\n";
const char r2[]="HTTP/1.1 200 OK\r\n";

const char h0[]="Server: petit\r\n";
const char h1[]="Content-Type: ";
const char h2[]="Transfer-Encoding: chunked\r\n";
const char h3[]="Content-Length: ";
const char h4[]="Content-Encoding: gzip\r\n";
const char h5[]="Connection: close\r\n";

const char c0[]="text/plain\r\n";
const char c1[]="text/html\r\n";
const char c2[]="image/gif\r\n";
const char c3[]="image/png\r\n";
const char c4[]="image/jpeg\r\n";
const char c5[]="image/x-icon\r\n";
const char c6[]="application/x-javascript\r\n";
const char c7[]="application/x-jar\r\n";

const char f0[]="\r\n";
// la direccion ip cambio...
const char m0[]="<html><head><title>Ajuste exitoso</title></head><body><h2>Ajuste exitoso</h2><p>La nueva direccin IP del servidor es: <a href=\"http:\\\\@1\" target=\"mainFrame\">@1</a></body></html>";
// no se pudo cambiar la ip...
const char m1[]="<html><head><title>Error</title></head><body><h2>Direcci&oacuten ocupada</h2>La direcci&oacuten IP solicitada est&aacute usada por @2<p>La direcci&oacuten IP del servidor no ha cambiado.</body></html>";


const char dias[]="SunMonTueWedThuFriSat";
const char meses[]="JanFebMarAprMayJunJulAugSepOctNovDec";

const int8 TableGetDayofWeek[13]={0,0,3,3,6,1,4,6,2,5,0,3,5};
const int8 numDiasMes[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};

/****************************************************************
* GetDayofWeek
* This routine calculate the Day(Sunday, Monday,...Saturday) of
* week when a Date(year, Month, Day) is given.
* Input : Year, Month and Day which in this routine is used
* as global variable.
* Output Variable : 1 to 7(which corr espond to Sunday to Saturdaday
* re spectively) if the input is acceptable, else a value 8 is return
*****************************************************************/
int8 GetDayofWeek(int8 Day, int8 Month, int8 CurrentYear){
   int8 TempYear, AccValue, Temp;
   CurrentYear+=100;
   if(CurrentYear<90 || CurrentYear >199)/* Return Error if input not Valid*/
      return 8;
   TempYear = 90;/*Comparation start with year 1990*/
   AccValue = 0;/*Init AccValue to 0*/
   /* If TempYear is a leap year AccValue +2, else AccValue+1 */
   while(TempYear != CurrentYear){
      AccValue++;
      if((TempYear&0x3)==0) // es ano bisiesto?
         AccValue++;
      TempYear++;
   }
   if(Month > 2){
      if((TempYear&0x3)==0) // es ano bisiesto?
         AccValue++;
   }
   AccValue += TableGetDayofWeek[Month];
   AccValue += Day;
   AccValue = AccValue%7;
   return (AccValue+1);
}

void tiempoLocalAGMT(){
   signed int8 temp;
   temp=DS1338_regs[DS1338_HOURS_REG]-DS1338_regs[DS1338_GMT_REG];
   DS1338_regs[DS1338_HOURS_REG]=temp;
   if(temp>=24){ //avanza al dia siguiente
      temp-=24;
      DS1338_regs[DS1338_HOURS_REG]=temp;
      DS1338_regs[DS1338_DATE_REG]++;
      if(DS1338_regs[DS1338_DATE_REG]>numDiasMes[DS1338_regs[DS1338_MONTH_REG]]){
         if(((DS1338_regs[DS1338_YEAR_REG]&0x3)==0) && (DS1338_regs[DS1338_MONTH_REG]==2)){ //es ano bisiesto y febrero?
            if(DS1338_regs[DS1338_DATE_REG]==30){
               DS1338_regs[DS1338_DATE_REG]=1;
               DS1338_regs[DS1338_MONTH_REG]++;
            }
         }
         else{
            DS1338_regs[DS1338_DATE_REG]=1;
            DS1338_regs[DS1338_MONTH_REG]++;
         }

         if(DS1338_regs[DS1338_MONTH_REG]>12){
            DS1338_regs[DS1338_MONTH_REG]=1;
            DS1338_regs[DS1338_YEAR_REG]++;
         }
      }
   }
   else if(temp<0){ // ir al dia anterior
      temp+=24;
      DS1338_regs[DS1338_HOURS_REG]=temp;
      DS1338_regs[DS1338_DATE_REG]--;
      if(DS1338_regs[DS1338_DATE_REG]==0){
         DS1338_regs[DS1338_MONTH_REG]--;
         DS1338_regs[DS1338_DATE_REG]=numDiasMes[DS1338_regs[DS1338_MONTH_REG]];
         if( ((DS1338_regs[DS1338_YEAR_REG]&0x3)==0) && (DS1338_regs[DS1338_MONTH_REG]==2)){ //es ano bisiesto y febrero?
            DS1338_regs[DS1338_DATE_REG]=29;
         }
         if(DS1338_regs[DS1338_MONTH_REG]==0){
            DS1338_regs[DS1338_MONTH_REG]=12;
            DS1338_regs[DS1338_DATE_REG]=numDiasMes[12];
            DS1338_regs[DS1338_YEAR_REG]--;
         }
      }
   }
}

char *catFecha(char *inicio){ // llamar a    DS1338_read_date_time(); antes que a esta funcion
   uint t;
   char *aux;
   aux=inicio;
   *aux++='D';
   *aux++='a';
   *aux++='t';
   *aux++='e';
   *aux++=':';
   *aux++=' ';

   t=(DS1338_regs[DS1338_DAY_OF_WEEK_REG]-1)*3;
   *aux++=dias[t++];
   *aux++=dias[t++];
   *aux++=dias[t++];
   sprintf(aux,", %02u ",DS1338_regs[DS1338_DATE_REG]);
   aux+=5;
   t=(DS1338_regs[DS1338_MONTH_REG]-1)*3;
   *aux++=meses[t++];
   *aux++=meses[t++];
   *aux++=meses[t++];
   sprintf(aux," %lu %02u:%02u:%02u GMT\r\n", DS1338_regs[DS1338_YEAR_REG]+2000 , DS1338_regs[DS1338_HOURS_REG], DS1338_regs[DS1338_MINUTES_REG],DS1338_regs[DS1338_SECONDS_REG]);
   aux+=20;
   return aux;
}
// obtener la hora del rtc y crear la cadena en buf
// regresar el num de caracteres escritos

uint obt_hora(char *buf){
   sint t;
   t=DS1338_regs[DS1338_GMT_REG];
   t=abs(t);
   sprintf(buf,"%02u/%02u/%lu %02u:%02u:%02u GMT %02u", DS1338_regs[DS1338_DATE_REG],DS1338_regs[DS1338_MONTH_REG],DS1338_regs[DS1338_YEAR_REG]+2000,DS1338_regs[DS1338_HOURS_REG], DS1338_regs[DS1338_MINUTES_REG],DS1338_regs[DS1338_SECONDS_REG],t);
   if((signed int)DS1338_regs[DS1338_GMT_REG]<0)
      buf[23]='+';
   else
      buf[23]='-';
   return 26;
}


uint16 crear_cabecera(uint resp,uint mime, uint atrib){
   char *inicio;
   inicio=tcp_buf=&packet[TCP_data];
   *tcp_buf=0;
   switch(resp){
      case 0:
         cstcpy(tcp_buf,r0);
         break;
      case 1:
         cstcpy(tcp_buf,r1);
         break;
      case 2:
         cstcpy(tcp_buf,r2);
         break;
   }

   cstcpy(tcp_buf,h0);
   tcp_buf=catFecha(tcp_buf);
   cstcpy(tcp_buf,h1);

   switch(mime){
      case 0:
         cstcpy(tcp_buf,c0);
         break;
      case 1:
         cstcpy(tcp_buf,c1);
         break;
      case 2:
         cstcpy(tcp_buf,c2);
         break;
      case 3:
         cstcpy(tcp_buf,c3);
         break;
      case 4:
         cstcpy(tcp_buf,c4);
         break;
      case 5:
         cstcpy(tcp_buf,c5);
         break;
      case 6:
         cstcpy(tcp_buf,c6);
         break;
      case 7:
         cstcpy(tcp_buf,c7);
         break;
   }

   switch(atrib){
      case 0: // binario
         cstcpy(tcp_buf,h3);
         sprintf(tcp_buf,"%lu\r\n",factual.tam);
         tcp_buf+=strlen(tcp_buf);
         break;
      case 1: // texto
         cstcpy(tcp_buf,h2);
         break;
      case 2: // gzip
         cstcpy(tcp_buf,h4);
         cstcpy(tcp_buf,h3);
         sprintf(tcp_buf,"%lu\r\n",factual.tam);
         tcp_buf+=strlen(tcp_buf);
         break;
      case 3: // close
         cstcpy(tcp_buf,h5);
         break;
   }
   cstcpy(tcp_buf,f0);
   return tcp_buf-inicio;
}




int16 generarPagina(int16 usado){
	int16 tmp;
   int8 t;
	char parm;
   char *iniRespuesta;
   char *iniTamContenido;

   if(feof)
      return;

   DS1338_regs[DS1338_GMT_REG]=-DS1338_regs[DS1338_GMT_REG];
   tiempoLocalAGMT();

   iniRespuesta=tcp_buf;

   tcp_buf+=5;

   while(!feof){
      parm=0;
      tmp=tcp_buf-iniRespuesta;
      if(tmp>=cnte->MSS-usado-33)
         break;

      tmp=freadtoken(tcp_buf,'@',&parm,cnte->MSS-usado-33-tmp);
      tcp_buf+=tmp;

      switch(parm){
      case '1':   // imprimir IP
         sprintf(tcp_buf,"%u.%u.%u.%u",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);
   	   tcp_buf+=strlen(tcp_buf);
         break;
      case '2':   // imprimir multicast
         sprintf(tcp_buf,"%u.%u.%u.%u",MCIP[0],MCIP[1],MCIP[2],MCIP[3]);
         tcp_buf+=strlen(tcp_buf);
         break;
      case '3':   // conexiones activas
         sprintf(tcp_buf,"%u",tcp_activas);
         tcp_buf+=strlen(tcp_buf);
         break;
   	case '4':   // hora
         t=DS1338_regs[DS1338_GMT_REG];
         t=abs(t);
         sprintf(tcp_buf,"%02u/%02u/%lu %02u:%02u:%02u GMT %02u", DS1338_regs[DS1338_DATE_REG],DS1338_regs[DS1338_MONTH_REG],DS1338_regs[DS1338_YEAR_REG]+2000,DS1338_regs[DS1338_HOURS_REG], DS1338_regs[DS1338_MINUTES_REG],DS1338_regs[DS1338_SECONDS_REG],t);
         if((signed int)DS1338_regs[DS1338_GMT_REG]<0)
            *(tcp_buf+23)='+';
         else
            *(tcp_buf+23)='-';
         tcp_buf+=26;
         break;
      case '5':   // direccion mac
         sprintf(tcp_buf,"%x-%x-%x-%x-%x-%x",MAC_ADDR_0,MAC_ADDR_1,MAC_ADDR_2,MAC_ADDR_3,MAC_ADDR_4,MAC_ADDR_5);
         tcp_buf+=strlen(tcp_buf);
         break;
      case '6':   // version
         sprintf(tcp_buf,"%u.%u",VMAY,VMEN);
         tcp_buf+=strlen(tcp_buf);
         break;
      case '7':   // puerto http
         sprintf(tcp_buf,"%lu",make16(MY_PORT_ADDRESS_H,MY_PORT_ADDRESS_L));
         tcp_buf+=strlen(tcp_buf);
         break;
      case '8':   // puerto udp
         sprintf(tcp_buf,"%lu",make16(pto_udp_h,pto_udp_l));
         tcp_buf+=strlen(tcp_buf);
         break;
      case '9':   // direccion ip y puerto nuevos despues de reset
         sprintf(tcp_buf,"%u.%u.%u.%u:%lu",t_ip[0],t_ip[1],t_ip[2],t_ip[3],make16(tpto_H,tpto_L));
   	   tcp_buf+=strlen(tcp_buf);
         break;
      case '0':   // direccion mac de la ip que yo queria usar
         sprintf(tcp_buf,"%x-%x-%x-%x-%x-%x",t_mac[0],t_mac[1],t_mac[2],t_mac[3],t_mac[4],t_mac[5]);
   	   tcp_buf+=strlen(tcp_buf);
         break;
      case 'a':   // rtc hora
         sprintf(tcp_buf,"%02u",DS1338_regs[DS1338_HOURS_REG]);
   	   tcp_buf+=2;
         break;
      case 'b':   // rtc minuto
         sprintf(tcp_buf,"%02u",DS1338_regs[DS1338_MINUTES_REG]);
     	   tcp_buf+=2;
         break;
      case 'c':   // rtc segundo
         sprintf(tcp_buf,"%02u",DS1338_regs[DS1338_SECONDS_REG]);
         tcp_buf+=2;
         break;
      case 'd':   // rtc dia
         sprintf(tcp_buf,"%02u",DS1338_regs[DS1338_DATE_REG]);
         tcp_buf+=2;
         break;
      case 'e':   // rtc mes
         sprintf(tcp_buf,"%02u",DS1338_regs[DS1338_MONTH_REG]);
         tcp_buf+=2;
         break;
      case 'f':   // rtc ano
         sprintf(tcp_buf,"%lu",DS1338_regs[DS1338_YEAR_REG]+2000);
         tcp_buf+=4;
         break;
      case 'g':   // rtc GMT
         sprintf(tcp_buf,"%d",12-(signed int)DS1338_regs[DS1338_GMT_REG]);
     	   tcp_buf+=strlen(tcp_buf);
         break;
      }

   }

   // calcular tamano del chunk
   parm=*(iniRespuesta+5);
   tmp=tcp_buf-iniRespuesta;
   sprintf(iniRespuesta,"%03Lx\r\n",tmp-5);
   *(iniRespuesta+5)=parm;
   // calcular tamano de toda la respuesta
   if(feof){
      *tcp_buf++='\r';
      *tcp_buf++='\n';
      *tcp_buf++='0';
      *tcp_buf++='\r';
      *tcp_buf++='\n';
      *tcp_buf++='\r';
      *tcp_buf++='\n';
      tmp+=7;
   }
   else{
      *tcp_buf++='\r';
      *tcp_buf++='\n';
      tmp+=2;
   }
   return tmp;
}

char *siguiente(void){
   char *aux;
   aux=tcp_buf;
   tcp_buf=strchr(tcp_buf,' ');
   if(tcp_buf == 0)
      return aux;
   *tcp_buf=0;
   tcp_buf++;
   return aux;
}

void http_enviar(int16 tmp){
   if(feof==0){
      usr->flags|=HTTP_ENVARCH;
      tcp_enviar(ACK,tmp);
   }else{
      usr->flags&=~HTTP_ENVARCH;
      tcp_enviar(PSH|ACK,tmp);
   }
}

void guardar_tiempo(){
   (usr->tstamp).seg=DS1338_regs[DS1338_SECONDS_REG];
   (usr->tstamp).min=DS1338_regs[DS1338_MINUTES_REG];
   (usr->tstamp).hora=DS1338_regs[DS1338_HOURS_REG];
   (usr->tstamp).dia=DS1338_regs[DS1338_DATE_REG];
   (usr->tstamp).mes=DS1338_regs[DS1338_MONTH_REG];
   (usr->tstamp).ano=DS1338_regs[DS1338_YEAR_REG];
   (usr->tstamp).dsem=DS1338_regs[DS1338_DAY_OF_WEEK_REG];
}

void restaurar_tiempo(){
   DS1338_regs[DS1338_SECONDS_REG]=(usr->tstamp).seg;
   DS1338_regs[DS1338_MINUTES_REG]=(usr->tstamp).min;
   DS1338_regs[DS1338_HOURS_REG]=(usr->tstamp).hora;
   DS1338_regs[DS1338_DATE_REG]=(usr->tstamp).dia;
   DS1338_regs[DS1338_MONTH_REG]=(usr->tstamp).mes;
   DS1338_regs[DS1338_YEAR_REG]=(usr->tstamp).ano;
   DS1338_regs[DS1338_DAY_OF_WEEK_REG]=(usr->tstamp).dsem;
}

void ev_tcp_ini(){
   usr=&usuarios[cnte->id];
   usr->tkeepalive=HTTP_MAX_ALIVE;
   usr->flags=0;
   usr->contenido=0;
   usr->npaq=0;
   usr->resp=0;
   usr->archivo=0;
}

void ev_tcp_fin(){
   int i;
   usr=&usuarios[cnte->id];
   usr->tkeepalive=0;
}


void http_tfuera(){
   uint i;
   for(i=0,usr=usuarios;i<MAX_CLIENTES;i++,usr++)
      if(usr->tkeepalive!=0){
         usr->tkeepalive--;
//       printf("\r\nhttp: keepalive %d %u",i,usr->tkeepalive);

         if(usr->tkeepalive==0){
#ifdef HTTP_DEBUG
            printf("\r\nhttp: keepalive tout %d",i);
#endif
            tcp_cerrar(i);
         }
      }

}

sint ev_tcp_psh(){
   char variable;
   sint16 valor;
   char *aux;
   char *ver;
   uint16 tmp;
   uint i,j;

   tcp_buf=&packet[TCP_data];
   usr=&usuarios[cnte->id];
   usr->tkeepalive=HTTP_MAX_ALIVE;
   usr->npaq=0;


/************************************************************* GET*/
   if(tcp_buf[0]=='G' && tcp_buf[1]=='E' &&tcp_buf[2]=='T' && tcp_buf[3]==' '){ // GET ?
      tcp_buf+=4;

      DS1338_read_date_time(); //obtener la hora del rtc para generar las cabeceras
      guardar_tiempo();

      aux=siguiente();
      ver=siguiente();
      printf("\r\n%d GET %s",cnte->id,aux);
      if(ver[0]=='H' && ver[1]=='T' && ver[2]=='T' && ver[3]=='P' && ver[4]=='/' && ver[5]=='1' && ver[6]=='.' && ver[7]=='0'){ // cerrar conexion al terminar de enviar
         usr->flags|=HTTP_CERRAR;
      }

      if(aux[0]=='/' && aux[1]==0){ // "/" ?
         fopen(p0); // enviar index.html
         usr->resp=2;
         tmp=crear_cabecera(2,factual.mime,factual.tipo);
         tmp+=fread(tcp_buf,cnte->MSS-tmp);
         usr->contenido=1;
      }
      else{
         aux++; // para eliminar la "/"
         if(fopen(aux)==0){ // abrir archivo solicitado
            usr->resp=2;
            if(factual.tipo==1){ // es (chunked) .egi o .js ?
               tmp=crear_cabecera(2,factual.mime,factual.tipo);
               tmp+=generarPagina(tmp);
               usr->contenido=2;
            }
            else{
               tmp=crear_cabecera(2,factual.mime,factual.tipo);
               tmp+=fread(tcp_buf,cnte->MSS-tmp);
               usr->contenido=1;
            }
         }
         else{
            fopen(p1); // archivo no encontrado, enviar not found
            usr->resp=0;
            tmp=crear_cabecera(0,factual.mime,factual.tipo);
            tmp+=fread(tcp_buf,cnte->MSS-tmp);
            usr->contenido=1;
         }
      }
      fclose();
      http_enviar(tmp);
      usr->npaq++;
      usr->archivo=factual;
      return 0;
   }

/************************************************************* POST*/
   if(tcp_buf[0]=='P' && tcp_buf[1]=='O' &&tcp_buf[2]=='S' &&tcp_buf[3]=='T' && tcp_buf[4]==' '){ // POST ?
      tcp_buf+=6; // hasta saltar la /

/*************************************************************  conf.egi*/
      if(tcp_buf[0]=='r'&&tcp_buf[1]=='t'&&tcp_buf[2]=='c'&&tcp_buf[3]=='.'&&tcp_buf[4]=='e'&&tcp_buf[5]=='g'&&tcp_buf[6]=='i'&&tcp_buf[7]==' '){ // "rtc.egi" ?
         // busqueda de parametros
         while(1){
            if(*tcp_buf=='\r')
               if(*(tcp_buf+1)=='\n')
                  if(*(tcp_buf+2)=='\r')
                     if(*(tcp_buf+3)=='\n')
                        break;
            tcp_buf++;
         }
         tcp_buf+=4;
         // asignar cada parametro a la variable correspondiente
escanear_rtc:
   		variable=*tcp_buf;
   		tcp_buf+=2;
   		aux=tcp_buf;
   		while(*tcp_buf!='&'){
   			if(*tcp_buf=='\0')
   				goto fin_escanear_rtc;
   			tcp_buf++;
   		}
   		*tcp_buf='\0';
   		valor=atol(aux);
   		tcp_buf++;
   		switch(variable){
   			case 'a':
               DS1338_regs[DS1338_DATE_REG]=valor;
   				break;
   			case 'b':
               DS1338_regs[DS1338_MONTH_REG]=valor;
   				break;
   			case 'c':
               DS1338_regs[DS1338_YEAR_REG]=valor-2000;
   				break;
   			case 'h':
               DS1338_regs[DS1338_HOURS_REG]=valor;
   				break;
   			case 'm':
               DS1338_regs[DS1338_MINUTES_REG]=valor;
   				break;
   			case 's':
               DS1338_regs[DS1338_SECONDS_REG]=valor;
   				break;
   			case 'u':
               DS1338_regs[DS1338_GMT_REG]=valor;
   				break;
   		}
   		goto escanear_rtc;
fin_escanear_rtc:
         tiempoLocalAGMT();
         DS1338_regs[DS1338_DAY_OF_WEEK_REG]=GetDayofWeek(DS1338_regs[DS1338_DATE_REG],DS1338_regs[DS1338_MONTH_REG],DS1338_regs[DS1338_YEAR_REG]);
         DS1338_set_date_time();
         DS1338_read_date_time(); // obtener hora del rtc para generar las cabeceras
         guardar_tiempo();
         fopen(p3); //hora.egi
         usr->resp=2;
         tmp=crear_cabecera(2,factual.mime,factual.tipo);
         tmp+=generarPagina(tmp);

         http_enviar(tmp);
         usr->archivo=factual;
         usr->contenido=2;
         fclose();

         return;
      }

      if(tcp_buf[0]=='t'&&tcp_buf[1]=='c'&&tcp_buf[2]=='p'&&tcp_buf[3]=='i'&&tcp_buf[4]=='p'&&tcp_buf[5]=='.'&&tcp_buf[6]=='e'&&tcp_buf[7]=='g'&&tcp_buf[8]=='i'){ // "tcpip.egi" ?
         // busqueda de parametros
         while(1){
            if(*tcp_buf=='\r')
               if(*(tcp_buf+1)=='\n')
                  if(*(tcp_buf+2)=='\r')
                     if(*(tcp_buf+3)=='\n')
                        break;
            tcp_buf++;
         }
         tcp_buf+=4;
         // asignar cada parametro a la variable correspondiente
         variable=*tcp_buf;
          j=0;
         while(j!=2){
            variable=*tcp_buf;
            if(variable=='a'){
               tcp_buf+=2;
               aux=tcp_buf;

               aux=strchr(tcp_buf,'.');
               *aux=0;
               t_ip[0]=atoi(tcp_buf);
               tcp_buf=++aux;

               aux=strchr(tcp_buf,'.');
               *aux=0;
               t_ip[1]=atoi(tcp_buf);
               tcp_buf=++aux;

               aux=strchr(tcp_buf,'.');
               *aux=0;
               t_ip[2]=atoi(tcp_buf);
               tcp_buf=++aux;

               aux=strchr(tcp_buf,'&');
               t_ip[3]=atoi(tcp_buf);
               tcp_buf=++aux;
               j++;
            } else if(variable=='b'){
               tcp_buf+=2;
               aux=tcp_buf;
               aux=strchr(tcp_buf,'&');
               *aux=0;
               tmp=atol(tcp_buf);
               tpto_L=make8(tmp,0);
               tpto_H=make8(tmp,1);
               tcp_buf=++aux;
               j++;
            } else{
               for(;;){
                  tcp_buf++;
                  if(*tcp_buf==0){
                     break;
                  }
                  else if(*tcp_buf=='&'){
                     tcp_buf++;
                     break;
                  }
               }
            }
         }
         tcp_enviar(ACK,0);
         arp_sol_mac_tip();
         printf("\r\npost :%u",cnte->id);
         ARP_PET=1;
         usr->flags|=HTTP_ADMIN; // este usuario esta modificando la configuracion. (there can be only one)
         return;
      }
/*
         swapMYIPtip();
         j=arp_buscar_MYIP();
         swapMYIPtip();

         if(j==0){
            fopen(p4);
            usr->flags|=HTTP_RSTCPU; // reset cpu al cerrar conexion
         }
         else{ //  Error al intentar cambiar ip
            fopen(p5);
         }


         tmp=crear_cabecera(2,factual.mime,factual.tipo);
         tmp+=generarPagina(tmp);

         http_enviar(tmp);
         usr->archivo=factual;
         usr->contenido=2;
         fclose();
         usr->flags|=HTTP_CERRAR;
         return 0;
      }*/

      printf("\r\n%d no se encuentra",cnte->id);
      fopen(p1); // archivo no encontrado, enviar not found
      usr->resp=0;
      tmp=crear_cabecera(0,factual.mime,factual.tipo);
      tmp+=fread(tcp_buf,cnte->MSS-tmp);

      http_enviar(tmp);
      usr->archivo=factual;
      usr->contenido=1;
      usr->npaq++;
      fclose();
      return 0;
   }

/************************************************************ HEAD*/
   if(tcp_buf[0]=='H' && tcp_buf[1]=='E' &&tcp_buf[2]=='A' &&tcp_buf[3]=='D' && tcp_buf[4]==' '){
      tcp_buf+=5;

      DS1338_read_date_time(); //obtener la hora del rtc para generar las cabeceras
      guardar_tiempo();
      aux=siguiente();

      if(aux[0]=='/' && aux[1]==0){ // "/" ?
         fopen(p0); // enviar index.html
         usr->resp=2;
         tmp=crear_cabecera(2,factual.mime,factual.tipo);
      }
      else{
         aux++; // para eliminar la "/"
         if(fopen(aux)==0){ // abrir archivo solicitado
               usr->resp=2;
               tmp=crear_cabecera(2,factual.mime,factual.tipo);
         }
         else{
            fopen(p1); // archivo no encontrado, enviar not found
            usr->resp=0;
            tmp=crear_cabecera(0,factual.mime,factual.tipo);
         }
      }
      fclose();
      usr->flags&=~HTTP_ENVARCH;
      usr->contenido=3;
      tcp_enviar(PSH|ACK,tmp);
      return 0;
   }

/************************************************* Not implemented*/
   DS1338_read_date_time(); //obtener la hora del rtc para generar las cabeceras
   guardar_tiempo();
   fopen(p2);  // enviar not implemented
   usr->resp=1;
   tmp=crear_cabecera(1,factual.mime,factual.tipo);
   tmp+=fread(tcp_buf,cnte->MSS-tmp);
   fclose();
   usr->flags&=~HTTP_ENVARCH;
   tcp_enviar(PSH|ACK,tmp);
   usr->contenido=1;
   usr->npaq++;
   return 0;
}

void ev_tcp_rtx(){
   uint16 tmp;
   char *aux;
   int i,j;

   usr=&usuarios[cnte->id];
   tcp_buf=&packet[TCP_data];
   restaurar_tiempo();   // recuperar la hora del paquete

   if(usr->contenido==1){ // contenido estatica

      usr->npaq--;
      if(usr->npaq==0){
         factual=usr->archivo;
         factual.ap=0; // leer desde el principio del archivo
         tmp=crear_cabecera(usr->resp,factual.mime,factual.tipo);
         freopen();
         tmp+=fread(tcp_buf,cnte->MSS-tmp);
      }
      else{
         factual=usr->archivo;
         factual.ap-=cnte->lude;
         freopen();
         tmp=fread(tcp_buf,cnte->MSS);
      }

      fclose();

      if(feof){
         usr->flags&=~HTTP_ENVARCH;
         tcp_re_enviar(PSH|ACK,tmp);
      }
      else
         tcp_re_enviar(ACK,tmp);
      usr->npaq++;
      return;
   }

   if(usr->contenido==2){

      usr->npaq--;

      if(usr->npaq==0){
         factual=usr->archivo;
         factual.ap=0; // leer desde el principio del archivo
         tmp=crear_cabecera(usr->resp,factual.mime,factual.tipo);
         freopen();
         tmp+=generarPagina(tmp);
      }
      else{
         factual=usr->archivo;
         factual.ap-=cnte->lude;
         freopen();
         tmp=generarPagina(0);
      }
      fclose();

      if(feof){
         usr->flags&=~HTTP_ENVARCH;
         tcp_re_enviar(PSH|ACK,tmp);
      }
      else
         tcp_re_enviar(ACK,tmp);

      usr->npaq++;
      return;
   }


   if(usr->contenido==3){ // fue un head
      tmp=crear_cabecera(usr->resp,(usr->archivo).mime,(usr->archivo).tipo);
      tcp_re_enviar(PSH|ACK,tmp);
      return;
   }
}


void http_init(){
   uint i;
   for(i=0,usr=usuarios;i<MAX_CLIENTES;i++,usr++){
      usr->tkeepalive=0;
      usr->contenido=0;
      usr->resp=0;
      usr->flags=0;
      usr->archivo=0;
   }
   printf("\r\nhttp: %d clientes listos",MAX_CLIENTES);
}



sint ev_tcp_ack(){
   int16 tmp;
   int i;
   usr=&usuarios[cnte->id];
   usr->tkeepalive=HTTP_MAX_ALIVE;
   if(usr->flags&HTTP_ENVARCH){
      tcp_buf=&packet[TCP_data];
      factual=usr->archivo;
      freopen();
      if(usr->contenido==1)
         tmp=fread(tcp_buf,cnte->MSS);
      else{
         tmp=generarPagina(0);
      }
      fclose();
      usr->archivo=factual;
      usr->npaq++;
      if(feof){
         usr->flags&=~HTTP_ENVARCH;
         tcp_enviar(PSH|ACK,tmp);
      }
      else
         tcp_enviar(ACK,tmp);
      return 0;
   }
   if(usr->flags&HTTP_RSTCPU){
      printf("\r\nAplicando nueva configuracion");
      MYIP[0]=t_ip[0];
      MYIP[1]=t_ip[1];
      MYIP[2]=t_ip[2];
      MYIP[3]=t_ip[3];
      MY_PORT_ADDRESS_H=tpto_H;
      MY_PORT_ADDRESS_L=tpto_L;
      guardar_configuracion();
      printf("\r\nPetit: reiniciando");
      reset_cpu();
   }
   if(usr->flags&HTTP_CERRAR)
      return -1;
}

void http_app2(int j){
   int16 tmp;
   int id;
   for(id=0,usr=usuarios;id<MAX_CLIENTES;id++,usr++){
      if(usr->flags & HTTP_ADMIN)
         break;
   }
   usr->flags&=~HTTP_ADMIN;
   printf("\r\nrespuesta a:%u",id);
   cnte=&clientes[id];
   usr=&usuarios[id];
   if(j==0){ // nadie respondio al arp
      fopen(p4);
      usr->flags|=HTTP_RSTCPU; // reset cpu al cerrar conexion
   }
   else{    //  direccion ip ocupada
      fopen(p5);
   }
   tmp=crear_cabecera(2,factual.mime,factual.tipo);
   tmp+=generarPagina(tmp);
   http_enviar(tmp);
   usr->archivo=factual;
   usr->contenido=2;
   fclose();
   usr->flags|=HTTP_CERRAR;
}

#endif
