/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

#include <stdlib.h>

int mislot;
int contador;
int1 resync;
int id_paq;
int16 muestra;


void tomar_muestra();


#int_timer1
void despierta(){
   set_timer1(0x8000);
   contador++;
   id_paq++;
   if(contador == 120){
      contador=0;
      resync=1;
   }
}

void init_pic(){
   set_tris_b(0xBF);
   set_tris_a(0x0d);
   T1CON=0x0E; // habilitar oscilador externo 32768;
   OSCCON=0x60;// habilitar oscilador interno 4mhz
   while(IOFS==FALSE);
   output_bit(PIN_A4,1);
   delay_ms(500); // esperar hasta que esten estables
   output_bit(PIN_A4,0);
   setup_adc_ports( AN0 );
   setup_adc(ADC_OFF);
   output_a(0x00);
   output_b(0x00);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_64);
}

void sync_beacon(){
   int16 inicio;
   inicio=0xfc00-2048*mislot;// o lo que es lo mismo: 0x10000-(2048*slot+1024);
   set_rx_mode();

esp_beacon:
   while(!nrf_dr1);
   read_nrf(paquete);
   if(paquete[ID]!=BEACON)
      goto esp_beacon;
   TMR1ON=0;
   set_timer1(inicio);
   TMR1ON=1;
   enable_interrupts(INT_TIMER1);
   enable_interrupts(GLOBAL);
}


void tomar_muestra(){
   signed int32 ad;
   signed int8 ent, frac;
   ADCON1=0X8F;
   ADCS1=0; // TAD 2 us
   ADCS0=1; // fosc/8 4MHZ -> 2us
   ADON=1;
   delay_us(500);
   GO=1;
   ad = read_adc();
   ADON=0;

   if(ad > 793){
      ad=-50000;
   }
   else if(ad > 764){
      ad=-352*ad + 229277;
   }
   else if(ad > 635){
      ad=-310*ad + 197107;
   }
   else if(ad > 470){
      ad=-302*ad + 192034;
   }
   else if(ad > 299){
      ad=-292*ad + 187322;
   }
   else if(ad > 122){
      ad=-283*ad + 184518;
   }
/*   else if(ad > 764){
      ad=-345*ad + 223448;
   }
   else if(ad > 635){
      ad=-310*ad + 196899;
   }
   else if(ad > 470){
      ad=-303*ad + 192424;
   }
   else if(ad > 299){
      ad=-292*ad + 187427;
   }
   else if(ad > 122){
      ad=-282*ad + 184463;
   }*/
   else{
      ad=150000;
   }
   ad=ad/10;
   ent=ad/100;
   frac=ad-ent*100;
   ent=ent-50;
   muestra=make16(ent,frac);
}


void iniciar(){
   int a=0;
   int intentos;

   mislot=MIDIR&0X0F;
   contador=0;
   resync=1;
   id_paq=0;

dormir:

   if(resync == 1){
      output_bit(PIN_A4,1);
      resync=0;
      sync_beacon();
      output_bit(PIN_A4,0);
   }

   output_a(0x00);
   nrf_cs   =  0;
   nrf_ce   =  0;
   nrf_clk  =  0;
   nrf_data =  1;
   dir_data =  0;


   sleep();
   while(IOFS==FALSE); // esperar hasta reloj estable


   dir_dr1=1;
   dir_cs=0;
   dir_ce=0;
   dir_clk=0;

   intentos=0;
   tomar_muestra();

retry:
   paquete[DST]      = CTDIR;
   paquete[RMT]      = MIDIR;
   paquete[SEQ]      = id_paq;
   paquete[FLAGS]    = 0x00;
   paquete[ID]       = TXSINC;
   paquete[DATOS]    = make8(muestra,1);
   paquete[DATOS+1]  = make8(muestra,0);

   intentos++;
   if(intentos==4){
      resync=1;
      goto dormir;
   }

   output_bit(PIN_A4,1);
   set_tx_mode();
   write_nrf(paquete);
   delay_us(2500);   // retraso para ahorro de bateria
   set_rx_mode();
   set_timer0(193); // 1.6ms max
   T0IF=0;
   while(nrf_dr1==0 && T0IF==0);
   if(nrf_dr1==0)
      goto retry;
   output_bit(PIN_A4,0);

   nrf_ce=0;// poner en cero para ahorrar bateria (pag 26, datasheet)
   read_nrf(paquete);
   if(paquete[DST]!=MIDIR || paquete[SEQ]!=id_paq || !paquete[FLAGS]&ACK )
      goto retry;

   if(paquete[FLAGS]&SYNC)
      resync=1;

   goto dormir;
}



