/************************************************************
* Copyrigth 2006 Miguel Angel Montano Medina UNAM           *
* Servidor web embebido                                     *
* Este software puede ser usado, copiado, modificado        *
* y distribuido por cualquier persona para usos personales  *
* o de investigacion siempre y cuando se mantenga esta      *
* licencia presente. No se autoriza el uso de este software *
* para fines comerciales.                                   *
************************************************************/

//#use  fast_io(b)


#ifdef NODO

   #byte PTOB     =  0x06
   #bit  nrf_dr1  =  PTOB.0
   #bit  nrf_cs   =  PTOB.3
   #bit  nrf_ce   =  PTOB.2
   #bit  nrf_clk  =  PTOB.5
   #bit  nrf_data =  PTOB.4

   #byte TRISB    =  0x86
   #bit  dir_dr1  =  TRISB.0
   #bit  dir_cs   =  TRISB.3
   #bit  dir_ce   =  TRISB.2
   #bit  dir_clk  =  TRISB.5
   #bit  dir_data =  TRISB.4
   #define NOPS   ;
#endif

#ifdef PROTO

   #byte PTOB     =  0x06
   #bit  nrf_dr1  =  PTOB.0
   #bit  nrf_cs   =  PTOB.2
   #bit  nrf_ce   =  PTOB.3
   #bit  nrf_clk  =  PTOB.4
   #bit  nrf_data =  PTOB.5

   #byte TRISB    =  0x86
   #bit  dir_dr1  =  TRISB.0
   #bit  dir_cs   =  TRISB.2
   #bit  dir_ce   =  TRISB.3
   #bit  dir_clk  =  TRISB.4
   #bit  dir_data =  TRISB.5
   #define NOPS   ;
#endif


#ifdef CONTROL
   #byte PTOB     =  0x06
   #bit  nrf_dr1  =  PTOB.0
   #bit  nrf_cs   =  PTOB.2
   #bit  nrf_ce   =  PTOB.3
   #bit  nrf_clk  =  PTOB.6
   #bit  nrf_data =  PTOB.7
   #byte TRISB    =  0x86
   #bit  dir_dr1  =  TRISB.0
   #bit  dir_cs   =  TRISB.2
   #bit  dir_ce   =  TRISB.3
   #bit  dir_clk  =  TRISB.6
   #bit  dir_data =  TRISB.7
   #define NOPS   delay_cycles(3);
#endif

#define BCDIR        0xFF
#define MAX_PAYLOAD  26

char paquete[MAX_PAYLOAD];


int const pconfig[15]={0xd0,0xd0,
                        0x00,0x00,0x00,0x00,0x00,
                        0x00,'u','n','a','m',
                        0x83,0x4f,0xB8};

int i0,j0;

// lamar para poner el nrf2401 en el modo de transmicion
void set_tx_mode(){
   dir_data=0;
   nrf_ce=0;
   nrf_cs=1;
   nrf_data=0;
   nrf_clk=1;
   NOPS;
   nrf_clk=0;
   NOPS;
   nrf_cs=0;
}


// lamar para poner el nrf2401 en el modo de recepcion
void set_rx_mode(){
   dir_data=0;
   nrf_ce=0;
   nrf_cs=1;
   nrf_data=1;
   nrf_clk=1;
   NOPS;
   nrf_clk=0;
   NOPS;
   nrf_cs=0;
   nrf_ce=1;
   nrf_data=0;
   dir_data=1;
}


//escribir 1 byte en el nrf2401
void write_byte_nrf(int dato){
   for(j0=0;j0<8;j0++){
      nrf_data=bit_test(dato,7);
      nrf_clk=1;
      NOPS;
      nrf_clk=0;
      NOPS;
      dato<<=1;
   }
}


//leer 1 byte en el nrf2401
int read_byte_nrf(){
   int dt;
   dt=0;
   for(j0=0;j0<8;j0++){
      dt<<=1;
      dt+=nrf_data;
      nrf_clk=1;
      NOPS;
      nrf_clk=0;
      NOPS;
   }
   return dt;
}


//Configurar el nrf2401 para su uso inicial
void init_nrf(){
   dir_data=0;
   dir_dr1=1;
   dir_cs=0;
   dir_ce=0;
   dir_clk=0;
   delay_ms(3);
   nrf_ce=0;
   nrf_cs=1;
   for(i0=0;i0<15;i0++)
      write_byte_nrf(pconfig[i0]);
   nrf_cs=0;
}


// escribir una cadena de caracteres (y enviarla por rf)
void write_nrf(char *paq){
   dir_data=0;
   nrf_ce=1;
   write_byte_nrf('u');
   write_byte_nrf('n');
   write_byte_nrf('a');
   write_byte_nrf('m');
   for(i0=0;i0<MAX_PAYLOAD;i0++)
      write_byte_nrf(paq[i0]);
   nrf_ce=0;
   delay_us(1280); // medicion experimental
}


// leer una cadena de caracteres (datos recibidos)
void read_nrf(char *paq){
   for(i0=0;i0<MAX_PAYLOAD;i0++){
      *paq=read_byte_nrf();
      ++paq;
   }
}


